<?php
/**
Plugin Name: WPML For AMP
Plugin URI: https://wordpress.org/plugins/accelerated-mobile-pages/
Description: WPML For AMP - Accelerated Mobile Pages for WPML Support
Version: 1.7.18
Author: Ahmed Kaludi, Mohammed Kaludi
Author URI: https://ampforwp.com/
Donate link: https://www.paypal.me/Kaludi/25usd
License: GPL2+
Text Domain: accelerated-mobile-pages-WPML-support
 */



define('AMPFORWP_WPML_SUPPORT_PLUGIN_DIR', plugin_dir_path( __FILE__ ));

if ( ! defined( 'AMP_WPML_VERSION' ) ) {
  define( 'AMP_WPML_VERSION', '1.7.18' );
}
define( 'AMP_WPML_STORE_URL', 'https://accounts.ampforwp.com' ); 
define( 'AMP_WPML_ITEM_NAME', 'WPML for AMP' );
define( 'AMP_WPML_LICENSE_PAGE', 'wpml-for-amp' );
if(! defined('AMP_WPML_ITEM_FOLDER_NAME')){
    $folderName = basename(__DIR__);
    define( 'AMP_WPML_ITEM_FOLDER_NAME', $folderName );
}

add_action('amp_init','ampforwp_auto_add_amp_menu_link_insert_wpml');
function ampforwp_auto_add_amp_menu_link_insert_wpml() {
 add_action( 'wp', 'ampforwp_auto_add_amp_in_link_check_wpml' );
}

function ampforwp_auto_add_amp_in_link_check_wpml() {
   add_filter( 'nav_menu_link_attributes', 'ampforwp_auto_add_amp_in_menu_link_wpml', 12, 3 );

}

function ampforwp_auto_add_amp_in_menu_link_wpml( $atts, $item, $args ) {
  if ( function_exists( 'ampforwp_is_amp_endpoint' ) && ampforwp_is_amp_endpoint() ) {
    if(ampforwp_get_setting('ampforwp-auto-amp-menu-link') == 1 ){
     $atts['href'] = preg_replace('/amp\/1\//', '',  $atts['href']);
     $atts['href'] =  $atts['href'];
     
     $url = $atts['href'];
     if(strpos($atts['href'], '?')!==false){
         $url = str_replace('%2F', '', $url);
     }
     $atts['href'] = $url;

   if(preg_match('/\?lang=(.*?)\/amp\//',  $atts['href'])){
    $atts['href'] = preg_replace('/\?lang=(.*?)\/amp\//', '?lang=$1&amp',  $atts['href']);
        $atts['href'] =  $atts['href'];
      }
      }
      if(ampforwp_get_setting('ampforwp-auto-amp-menu-link') == 0 ){
   $atts['href'] = preg_replace('/amp\/1/', '',  $atts['href']);
   //$atts['href'] = preg_replace('/(.*)/', '$1amp/',  $atts['href']);
   $atts['href'] = preg_replace_callback('/^(http[s]?:\/\/)?(.*)$/', function($matches){
      $matches[0] = function_exists('ampforwp_url_controller') ? ampforwp_url_controller($matches[0]) : $matches[0];
    return $matches[0]; 
    }, $atts['href']);
    $atts['href'] = preg_replace('/\/amp\/amp/', '/amp',  $atts['href']);
     $atts['href'] =  $atts['href'];
  }
}
  return $atts;
}
$locations = get_nav_menu_locations();
if($locations =="amp-menu"){
 add_filter('ampforwp_menu_content','amp_wpml_render_menu_items');
}
function amp_wpml_render_menu_items($menu_html_content){
      $menu_args = array(
                    'theme_location' => 'amp-menu',
                    'container'=>'aside',
                    'menu'=>'ul',
                    'menu_class'=>'amp-menu',
                    'echo' => false,
                    'walker' => new Ampforwp_Walker_Nav_Menu()
                );
      $menu_html_content = wp_nav_menu( $menu_args );
  return $menu_html_content; 
}

require_once AMPFORWP_WPML_SUPPORT_PLUGIN_DIR.'admin_side/admin_operation.php';
require_once AMPFORWP_WPML_SUPPORT_PLUGIN_DIR.'view_options/view_operation.php';
 
// Plugin activation check starts here //
//*************************************//
include_once( ABSPATH . 'wp-admin/includes/plugin.php' );
if ( !is_plugin_active( 'sitepress-multilingual-cms/sitepress.php' ) ) {

add_filter( 'plugin_action_links', 'ampforwp_wpml_plugin_activation_check', 15, 5 );

add_action( 'admin_notices', 'plugin_wpml_admin_notice' );

return;
}

// Add Activate Parent Plugin button in settings page
function ampforwp_wpml_plugin_activation_check( $actions, $plugin_file ) {
  static $plugin;
  if (!isset($plugin))
    $plugin = plugin_basename(__FILE__);
    if ($plugin == $plugin_file) {
        $settings = array('settings' => '<p style="color:#000;">Please Activate the WPML Plugin</p>');
        $actions = array_merge($settings , $actions );
      }
    return $actions;
}

function plugin_wpml_admin_notice(){
    ?>
    <div class="notice notice-success is-dismissible" style="border-left-color: #dc3232;">
        <p><?php esc_html_e( 'WPML Plugin is not activated. The WPML Plugin must be installed and activated before you use the \'WPML for AMP\' plugin.' ); ?></p>
    </div>
    <?php 
}

if(class_exists('SitePress')){
add_filter( 'option_rewrite_rules', 'ampforwp_custom_rewrite_rules_for_translated_product_archive_pages',10,1);
}

function ampforwp_custom_rewrite_rules_for_translated_product_archive_pages($rules){

  global $sitepress, $sitepress_settings,$woocommerce_wpml;
      if(!isset($get_ls_args)){
          $get_ls_args = "";
      }
      $languages = $sitepress->get_ls_languages( $get_ls_args );
      $array1 = array();
      $result = $rules;
        foreach ($languages as $lang => $data) {
          $lang_code = $data['code'];
          $tag_taxonomies =  'product_tag';
          $cat_taxonomies =  'product_cat';
        if(class_exists('WCML_Url_Translation') && function_exists('wpml_tm_load')){
        if(!empty($translated_product_cat_slug)){
         $translated_product_tag_slug = $woocommerce_wpml->url_translation->get_translated_tax_slug($tag_taxonomies , $lang_code);
         }
        if(!empty($translated_product_cat_slug)){
         $translated_product_cat_slug = $woocommerce_wpml->url_translation->get_translated_tax_slug($cat_taxonomies , $lang_code);
        }

        if(isset($translated_product_tag_slug["translated_slug"])){ 
         $array1[$translated_product_tag_slug["translated_slug"].'/([^/]+)/amp/?$'] = 'index.php?product_tag=$matches[1]&amp=1';
          $array1[$translated_product_tag_slug["translated_slug"].'/([^/]+)/amp/page/?([0-9]{1,})/?$'] = 'index.php?product_tag=$matches[1]&paged=$matches[2]&amp=1'
              ;
        }      

        if(isset($translated_product_cat_slug["translated_slug"])){
         $array1[$translated_product_cat_slug["translated_slug"].'/(.+?)/amp/?$'] = 'index.php?product_cat=$matches[1]&amp=1';
         $array1[$translated_product_cat_slug["translated_slug"].'/(.+?)/amp/page/?([0-9]{1,})/?$'] = 'index.php?product_cat=$matches[1]&paged=$matches[2]&amp=1';
        } 
         }
     }

    if(!empty($array1) && !empty($rules) && is_array($rules) && is_array($array1)){
             $result = @array_merge($array1,$rules);
    }
    return $result;

}

if(is_plugin_active('no-category-base-wpml/no-category-base-wpml.php')){
    add_action('created_category', 'wpml_amp_flush_rewrite_rules', 999);
    add_action('delete_category', 'wpml_amp_flush_rewrite_rules', 999);
    add_action('edited_category', 'wpml_amp_flush_rewrite_rules', 999);
    add_filter('category_rewrite_rules', 'amp_wpml_category_base_remover');
}

function wpml_amp_flush_rewrite_rules( $hard=true ) {
  global $wp_rewrite;
  $wp_rewrite->flush_rules( $hard );
}

if(!function_exists('amp_wpml_category_base_remover')){
  function amp_wpml_category_base_remover($category_rewrite){
    global $wp_rewrite;
    /* WPML is present: temporary disable terms_clauses filter to get all categories for rewrite */
    if ( class_exists( 'Sitepress' ) ) {
      global $sitepress;
      remove_filter( 'terms_clauses', array( $sitepress, 'terms_clauses' ) );
      $categories = get_categories( array( 'hide_empty' => false ) );
      add_filter( 'terms_clauses', array( $sitepress, 'terms_clauses' ), 10, 4 );
    } else {
      $categories = get_categories( array( 'hide_empty' => false ) );
    }

    foreach( $categories as $category ) {
      $category_nicename = $category->slug;

      if ( $category->parent == $category->cat_ID ) {
        $category->parent = 0;
      } elseif ( $category->parent != 0 ) {
        $category_nicename = get_category_parents( $category->parent, false, '/', true ) . $category_nicename;
      }

      $category_rewrite['('.$category_nicename.')/amp/(?:feed/)?(feed|rdf|rss|rss2|atom)/?$'] = 'index.php?category_name=$matches[1]&feed=$matches[2]&amp=1';
      $category_rewrite["({$category_nicename})/amp/{$wp_rewrite->pagination_base}/?([0-9]{1,})/?$"] = 'index.php?category_name=$matches[1]&paged=$matches[2]&amp=1';
      $category_rewrite['('.$category_nicename.')/amp/?$'] = 'index.php?category_name=$matches[1]&amp=1';
    }
    
    return $category_rewrite;
  }
}

if(class_exists('SitePress')){
add_action('amp_post_template_css', 'amp_wpml_render_submenu_flags');
}

function amp_wpml_render_submenu_flags(){

 global $sitepress;
   if(!isset($get_ls_args)){
      $get_ls_args = "";
   }
  $languages = $sitepress->get_ls_languages( $get_ls_args );
  $theme_location = get_nav_menu_locations();

 if($theme_location['amp-menu'] == isset($theme_location['amp-alternative-menu']) && $theme_location['amp-alternative-menu']){
            foreach ($languages as $lang => $data) {
            echo ".menu-item-wpml-ls-".esc_attr($theme_location['amp-menu'])."-".esc_attr($data['code'])." {background-image:url(". esc_url($data["country_flag_url"])."); background-repeat:no-repeat;padding:5px;}" ." \n";
            echo ".wpml-ls-menu-item amp-img {display:none}" ." \n";
          }
  }else{
     foreach ($languages as $lang => $data) {
        echo ".menu-item-wpml-ls-".esc_attr($theme_location['amp-menu'])."-".esc_attr($data['code'])." {background-image:url(". esc_url($data["country_flag_url"])."); background-repeat:no-repeat;padding:5px;}" ." \n";
        echo ".wpml-ls-menu-item amp-img {display:none}" ." \n";
      }
      if(isset($theme_location['amp-alternative-menu'])){
        foreach ($languages as $lang => $data) {
          echo ".menu-item-wpml-ls-".esc_attr($theme_location['amp-alternative-menu'])."-".esc_attr($data['code'])." {background-image:url(". esc_url($data["country_flag_url"])."); background-repeat:no-repeat;padding:5px;}" ." \n";
          echo ".wpml-ls-menu-item amp-img {display:none}" ." \n";
        }
      }
    }

}

add_action('pre_amp_render_post','ampforwp_wpml_redirect_checker');
function ampforwp_wpml_redirect_checker(){
  global $sitepress;
$automatic_redirect = $sitepress->get_setting( 'automatic_redirect' );
$remember_language = $sitepress->get_setting( 'remember_language' );
if($automatic_redirect == 2 && $remember_language == '24' ){
  add_filter('ampforwp_the_content_last_filter','ampforwp_wpml_redirect',999);
}
}

function ampforwp_wpml_redirect($cb){
 preg_match_all('/amp lang="(.*?)"/', $cb, $matches_lang);
  $new = $matches_lang[1][0] ;
  $to_run = preg_replace('/(.*?)-(..)/s', '$1', $new);
  $lang = substr($_SERVER['HTTP_ACCEPT_LANGUAGE'], 0, 2);
  $Browser_lang = ['fr', 'it', 'en'];
  $lang = in_array($lang, $Browser_lang) ? $lang : 'en';
  if ($lang && $to_run!=$lang ) {
    preg_match_all('/<link rel="alternate" hreflang="'.$lang.'" href="(.*?)"(.*?)>/', $cb, $matches);  
  $match1 = json_encode($matches[1]);
  $m_update = preg_replace('/\["(.*?)"\]/', '$1', $match1);
  $url_modify = preg_replace('/"/', '', $m_update);  
  $url = stripslashes($url_modify);
  $url_f = preg_replace('/\/amp/', '/amp', $url);
  wp_safe_redirect($url_f);
}
else return $cb;
}


require_once dirname( __FILE__ ) . '/updater/EDD_SL_Plugin_Updater.php';
// Check for updates
function amp_wpml_plugin_updater() {

    // retrieve our license key from the DB
    //$license_key = trim( get_option( 'amp_ads_license_key' ) );
    $selectedOption = get_option('redux_builder_amp',true);
    $license_key = '';//trim( get_option( 'amp_ads_license_key' ) );
    $pluginItemName = '';
    $pluginItemStoreUrl = '';
    $pluginstatus = '';
    if( isset($selectedOption['amp-license']) && "" != $selectedOption['amp-license'] && isset($selectedOption['amp-license'][AMP_WPML_ITEM_FOLDER_NAME])){

       $pluginsDetail = $selectedOption['amp-license'][AMP_WPML_ITEM_FOLDER_NAME];
       $license_key = $pluginsDetail['license'];
       $pluginItemName = isset($pluginsDetail['item_name'])&& $pluginsDetail['item_name'];
       $pluginItemStoreUrl = $pluginsDetail['store_url'];
       $pluginstatus = $pluginsDetail['status'];
    }
    
    // setup the updater
    $edd_updater = new AMP_WPML_EDD_SL_Plugin_Updater( AMP_WPML_STORE_URL, __FILE__, array(
            'version'   => AMP_WPML_VERSION,                // current version number
            'license'   => $license_key,                        // license key (used get_option above to retrieve from DB)
            'license_status'=>$pluginstatus,
            'item_name' => AMP_WPML_ITEM_NAME,          // name of this plugin
            'author'    => 'Mohammed Kaludi',                   // author of this plugin
            'beta'      => false,
        )
    );
}
add_action( 'admin_init', 'amp_wpml_plugin_updater', 0 );

// Notice to enter license key once activate the plugin
  $path = plugin_basename( __FILE__ );
    add_action("after_plugin_row_{$path}", function( $plugin_file, $plugin_data, $status ) {
        global $redux_builder_amp;

        if(! defined('AMP_WPML_ITEM_FOLDER_NAME')){
            $folderName = basename(__DIR__);
            define( 'AMP_WPML_ITEM_FOLDER_NAME', $folderName );
        }
        $pluginstatus = '';
        if(isset($redux_builder_amp['amp-license'][AMP_WPML_ITEM_FOLDER_NAME])){
        $pluginsDetail = $redux_builder_amp['amp-license'][AMP_WPML_ITEM_FOLDER_NAME];
        $pluginstatus = $pluginsDetail['status'];
        }
        if(empty($redux_builder_amp['amp-license'][AMP_WPML_ITEM_FOLDER_NAME]['license'])){
            echo "<tr class='active'><td>&nbsp;</td><td colspan='2'><a href='".esc_url(  self_admin_url( 'admin.php?page=amp_options&tabid=opt-go-premium' )  )."'>Please enter the license key</a> to get the <strong>latest features</strong> and <strong>stable updates</strong></td></tr>";
        }elseif($pluginstatus=="valid"){
            $update_cache = get_site_transient( 'update_plugins' );
            $update_cache = is_object( $update_cache ) ? $update_cache : new stdClass();
            if(isset($update_cache->response[ AMP_WPML_ITEM_FOLDER_NAME ]) 
                && empty($update_cache->response[ AMP_WPML_ITEM_FOLDER_NAME ]->download_link) 
              ){
               unset($update_cache->response[ AMP_WPML_ITEM_FOLDER_NAME ]);
            set_site_transient( 'update_plugins', $update_cache );
            }
            
        }
    }, 10, 3 );

if(class_exists('WPML_SEO_HeadLangs') && class_exists('WPML_Queried_Object_Factory'))
    {
        add_action( 'amp_post_template_head', 'amp_wpml_hreflang_sitepress' );
        function amp_wpml_hreflang_sitepress() 
            {
        global $sitepress;
        $sitepress_wpml = new WPML_SEO_HeadLangs($sitepress, new WPML_Queried_Object_Factory() );
        $sitepress_wpml->head_langs();
            }
        if(isset($redux_builder_amp['amp-frontpage-select-option']) && $redux_builder_amp['amp-frontpage-select-option'] == 1){    
          $current_url = $_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI'];
          $url_check  = explode('/', $current_url);
          $lang_check = count($url_check)-1;
          //print_r($url_check);die;
          if(in_array('amp', $url_check) || in_array('?amp', $url_check) ||
          strpos($url_check[$lang_check], "&amp") == true ) { 
          $current_url = preg_replace('/(\/\?lang=(.*?)&amp=1)|(\/\?lang=(.*?)&amp)|(\/amp\/)|(\/\?amp)/', '',  $current_url);
          $checker = get_site_url();
          $checker = str_replace(array('http://','https://'), array('',''),$checker);
              if ($current_url == $checker) { 
               add_action( 'amp_post_template_head', 'amp_wpml_hreflang_home' );
              }  
            }
        }
        function amp_wpml_hreflang_home(){   
          $hrefattrs = icl_get_languages();
          $i = 0;
          foreach ( $hrefattrs as $hrefattr ) {
            $hreflang = '';
            if($i == 0){
              $hreflang .= '<link rel="alternate" hreflang="' . esc_attr( $hrefattr['tag'] ) . '" href="' . esc_url( $hrefattr['url'] ) . '/" />' . PHP_EOL;
            }  
            // else {
            //     $hreflang .= '<link rel="alternate" hreflang="' . esc_attr( $hrefattr['tag'] ) . '" href="' . esc_url( $hrefattr['url'] ) . '" />' . PHP_EOL;
            // }
            $i++;
          }
              echo apply_filters( 'wpml_hreflangs_home_amp', $hreflang );
          }
    }

add_filter('wpml_hreflangs_home_amp','hreflangs_html_amp_remover');
add_filter('wpml_hreflangs_html','hreflangs_html_amp_remover');
function hreflangs_html_amp_remover($hreflang){
  $hreflang = preg_replace('/amp\/1/', '',  $hreflang);
  global $redux_builder_amp;
  $current_url = $_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI'];
  $url_check  = explode('/', $current_url);
  $lang_check = count($url_check)-1;
  if(in_array('amp', $url_check) || in_array('?amp', $url_check) ||
  strpos($url_check[$lang_check], "&amp") == true ) {
      if($redux_builder_amp['amp-core-end-point'] == 0 ) {
        //$hreflang = preg_replace('/href="(.*?)"/', 'href="$1/amp/"',  $hreflang);
        $hreflang = preg_replace_callback('/href="(.*?)"/', function($matches) {
          $slash_modifier = rtrim($matches[1],"/");
          return 'href="'.$slash_modifier.'/amp/"';
         }, $hreflang);
        }
      if($redux_builder_amp['amp-core-end-point'] == 1 ) { 
        $hreflang = preg_replace('/href="(.*?)"/', 'href="$1?amp"',  $hreflang); 
      }
      if(preg_match('/href="(.*?)\/\?lang=(.*?)amp\/"/', $hreflang)){
        $hreflang = preg_replace('/href="(.*?)\/\?lang=(.*?)amp\/"/', 'href="$1/?lang=$2&amp;amp"', $hreflang);
      }
      if(preg_match('/href="(.*?)\/\?lang=(.*?)?amp"/', $hreflang)){
        $hreflang = preg_replace('/href="(.*?)\/\?lang=(.*?)\?amp"/', 'href="$1/?lang=$2&amp;amp"', $hreflang);
      }
  }
  return $hreflang;  
}

//author bio translation.
add_filter('ampforwp_author_description','the_author_description_translation');
function the_author_description_translation($author_description){
   if( true == ampforwp_get_setting('amp-author-box-description') ){
      ob_start();
      the_author_description();
      $author_description = ob_get_contents();
      ob_get_clean();
      $author_description = '<p>'.$author_description.'</p>';
   }
    return $author_description;
}

add_filter('amp_post_template_css', 'amp_wpml_custom_styles');
function amp_wpml_custom_styles(){
    global $redux_builder_amp,$sitepress;
   
    if(4 == $redux_builder_amp['amp-design-selector']){
        $wpml_custom_css = '
        amp-img{display:none;}
        .m-menu .amp-menu > li.wpml-ls-item-'.ICL_LANGUAGE_CODE.' > a {
            background: url('.ICL_PLUGIN_URL.'/res/flags/'.ICL_LANGUAGE_CODE.'.png) no-repeat 6px center;
            padding: 10px 15px 22px 25px;
            display: inline-block;
            margin-right:10px;   
            color: #eee;
            width: 94%;
            }
        .p-menu .amp-menu > li.wpml-ls-item-'.ICL_LANGUAGE_CODE.' > a > amp-img {
            width: 15px;
            position: relative;
            left: -18px;
            top: 18px;
        }
        .f-menu .menu > li.wpml-ls-item-'.ICL_LANGUAGE_CODE.' > a > span > amp-img {
            width: 15px;
            position: relative;
            left: -18px;
            top: 18px;
        }
        ';
        echo $wpml_custom_css;
    }
 if( ICL_LANGUAGE_CODE == 'he' )
    {
        $rtl_custom_css = '
        .body{direction:rtl;}
        .toggle-navigationv2 ul li a {
        padding: 11px 61px 10px 8px;}
        .cl-btn:after {
        right: 5px;}
        .menu-item amp-img {left: 15px;bottom: -2px;}
        .hamburgermenu{float:right;}
        .toast{padding-right: 10px;}
        .callnow {position: absolute;float: left;left: 60px;right:1289px;}
        .wpcf7-text {color: #111;width: 900px;margin: 8px;}
        .wpcf7-form-control{max-width: 100%;}
        .w-bl{direction:rtl;}
        .loop-wrapper{direction:rtl;}
        .breadcrumb, .amp-category{direction:rtl;}
        .item-home:after {padding-right: 5px;}
        .amp-post-title{text-align: right;}
        .post-date .post-edit-link {float: left;}
        .sp-rt{direction: rtl;margin-right: 50px;margin-left:0;}
        .sp-rt .amp-author .amp-author-image {float: right;}
        .amp-author-image amp-img {margin: 0px 0px 5px 12px;}
        .prev {float: right;}
        .next {float: left;}
        .r-pf{direction:rtl;}
        .prev:after {left: -25px;right:auto;}
        .f-menu, .p-menu{direction:rtl;}
        .sp-lt {direction: rtl;}
        .comment-meta amp-img {float: right;margin-left: 10px;}
        .archive .author-img {float: right;}
        .archive  .author-img amp-img {margin: 0px 0px 10px 12px;}
        .amp-archive-title, .amp-archive-desc{text-align:right;}
        ';
     // Menu RTL Styles 
    if($redux_builder_amp['header-position-type'] == '1'){
        $rtl_custom_css .= '.tg:checked + .hamb-mnu > .m-ctr {
        margin-right: 0%;}
        .m-ctr{
         margin-right: -100%;
         float: left;
        }';
    }
    if($redux_builder_amp['header-position-type'] == '2'){
        $rtl_custom_css .='.tg:checked + .hamb-mnu > .m-ctr {
        margin-right: calc(100% -);
         }
        .m-ctr{
        margin-right: 100%;
         float: right;
        }
        }';
    }
    echo $rtl_custom_css;
        }
    }